
// Header of PCX file.
struct Header
	{
	uc Man;
	uc Ver;
	uc Enc;
	uc BitsPerPixel;
	ul Ymax;
	ul Ymin;
	ul Xmax;
	ul Xmin;
	ul HDpi;
	ul VDpi;
	uc Reserved;
	uc Nplanes;
	ul BytesPerLine;
	ul Palette;
	ul HScreensize;
	ul VScreensize;

	};
struct Header hdr;

encget(pbyt, pcnt, fid)
int *pbyt;        /* where to place data */
int *pcnt;        /* where to place count */
FILE *fid;        /* image file handle */
{
int i;
		*pcnt = 1;        /* assume a "run" length of one */
		if (EOF == (i = getc(fid)))
				return (EOF);
		if (0xC0 == (0xC0 & i))
				{
				*pcnt = 0x3F & i;
				if (EOF == (i = getc(fid)))
						return (EOF);
				}
		*pbyt = i;
		return (0);
}
/* Subroutine for writing an encoded byte pair (or single byte if it
doesn't encode) to a file. It returns the count of bytes written, 0 if error */

encput(byt, cnt, fid)
unsigned char byt, cnt;
FILE *fid;
{
  if (cnt) {
		if ((cnt == 1) && (0xC0 != (0xC0 & byt)))
				{
				if (EOF == putc((int )byt, fid))
						return(0);     /* disk write error (probably full) */
				return(1);
				}
		else
				{
				if (EOF == putc((int )0xC0 | cnt, fid))
						return (0);      /* disk write error */
				if (EOF == putc((int )byt, fid))
						return (0);      /* disk write error */
				return (2);
				}
		}
   return (0);
}

/* This subroutine encodes one scanline and writes it to a file.
It returns number of bytes written into outBuff, 0 if failed. */

encLine(inBuff, inLen, fp)
unsigned char *inBuff;    /* pointer to scanline data */
int inLen;                        /* length of raw scanline in bytes */
FILE *fp;                        /* file to be written to */
{
unsigned char this, last;
int srcIndex, i;
register int total;
register unsigned char runCount;     /* max single runlength is 63 */
  total = 0;
  runCount = 1;
  last = *(inBuff);

/* Find the pixel dimensions of the image by calculating
[XSIZE = Xmax - Xmin + 1] and [YSIZE = Ymax - Ymin + 1].
Then calculate how many bytes are in a "run" */

  for (srcIndex = 1; srcIndex < inLen; srcIndex++)
		{
		this = *(++inBuff);
		if (this == last)     /* There is a "run" in the data, encode it */
				{
				runCount++;
				if (runCount == 63)
						{
						if (! (i = encput(last, runCount, fp)))
								return (0);
						total += i;
						runCount = 0;
						}
				}
        else                /* No "run"  -  this != last */
				{
				if (runCount)
                        {
                        if (! (i = encput(last, runCount, fp)))
                                return(0);
						total += i;
						}
				last = this;
				runCount = 1;
				}
		}        /* endloop */
  if (runCount)        /* finish up */
		{
		if (! (i = encput(last, runCount, fp)))
				return (0);
		return (total + i);
		}
  return (total);
}


char far *get(FILE *fp,char far *bufr,char *mem,int disp)// gets palette & bitmap from PCX 16 color file
	{
	union REGS inregs;
	struct SREGS segregs;

	int chr=0,cnt=0,i=0;
	unsigned char r=0,g=0,b=0;
	unsigned long l=0,lsize=0;
	char far *init=0;

	 fseek(fp,0,SEEK_SET);
	 hdr.Man=fgetc(fp);
	 hdr.Ver=fgetc(fp);
	 hdr.Enc=fgetc(fp);
	 hdr.BitsPerPixel=fgetc(fp);
	 hdr.Xmin=fgetc(fp)+(fgetc(fp)*256);
	 hdr.Ymin=fgetc(fp)+(fgetc(fp)*256);
	 hdr.Xmax=fgetc(fp)+(fgetc(fp)*256);
	 hdr.Ymax=fgetc(fp)+(fgetc(fp)*256);
	 hdr.HDpi=fgetc(fp)+(fgetc(fp)*256);
	 hdr.VDpi=fgetc(fp)+(fgetc(fp)*256);
	 if(hdr.Ver>=5)
		{
		cprintf("\r\n Version Greater than 5");
		for(l=0,i=0;l<48;i++)
			{
			r=fgetc(fp);
			g=fgetc(fp);
			b=fgetc(fp);
			r/=4;
			g/=4;
			b/=4;
			cprintf("\r\n Index %2d : %3d Red. ",l/3,r);  	mem[l]=r;	l++;
			cprintf(" %3d Green. ",g);   					mem[l]=g;	l++;
			cprintf(" %3d Blue. ",b);   					mem[l]=b;	l++;

			if(i>255)
				break;
			}

/*                inregs.h.ah = 0x10;
		inregs.h.al = 0x12;
		if(disp==0)
			{
			inregs.x.bx = 0;
			inregs.x.cx = 16;
			}
		else
			{
			inregs.x.bx = 16;
			inregs.x.cx = 16;
			}
		inregs.x.dx = FP_OFF(mem);
		segregs.es = FP_SEG(mem);
		int86x(0x10, &inregs, &inregs, &segregs); //change palette.
*/

	 }
	 hdr.Reserved=fgetc(fp);
	 hdr.Nplanes=fgetc(fp);
	 hdr.BytesPerLine=fgetc(fp)+(fgetc(fp)*256);
	 hdr.Palette=fgetc(fp)+(fgetc(fp)*256);
	 hdr.HScreensize=fgetc(fp)+(fgetc(fp)*256);
	 hdr.VScreensize=fgetc(fp)+(fgetc(fp)*256);
	 fseek(fp,128L,SEEK_SET);
	 lsize = (long )hdr.BytesPerLine * hdr.Nplanes * (1 + hdr.Ymax - hdr.Ymin);
	if(lsize!=32000L)
		{
		Setmode(0x03);
		printf("\r\nSize : %ld \n\n Error : Not a valid 16 color PCX file ! \r\n\n\n",lsize);
		farfree(screen);
		if(bufr1!=0) farfree(bufr1);
		if(bufr2!=0) farfree(bufr2);
		exit(0);
		}

	if(bufr!=NULL) farfree(bufr);
	if ((bufr = (char far *) farmalloc(lsize+1000L)) == NULL)
		{
		printf("Not enough memory to allocate buffer\n");
		exit(1);  /* terminate program if out of memory */
		}
	 init=bufr;
	 for (l = 0; l < lsize; )             /* increment by cnt below */
				{
				if (EOF == encget(&chr, &cnt, fp))
						break;
				for (i = 0; i < cnt; i++)
						*bufr++ = chr;
				l += cnt;
				}

	return init;
	}


char far *view(char *file1,char far *bufr,char *mem,int disp) //converts the bitmap to linear bitmap
	{
	FILE *fp;

	int i=0,t=0,m=0;
	long l=0;
	unsigned char k=0, color=0;
	char far *init=0;
	char far *init1=0;

	if ((fp = fopen(file1, "rb"))
		== NULL)
		{
		Setmode(0x03);
		fprintf(stderr, "ERROR: Could not open the file named :   %s \n",file1);
		farfree(screen);
		if(bufr1!=0) farfree(bufr1);
		if(bufr2!=0) farfree(bufr2);
		exit(0);
		}
	init=get(fp,bufr,mem,disp);
	if ((init1 = (char far *) farmalloc(65000L)) == NULL)
		{
		printf("Not enough memory to allocate buffer\n");
		exit(1);  /* terminate program if out of memory */
		}

	l=0; k=0x80;
	m=7;
	for(i=0;i<200;i++)
		{
		for(t=0;t<320;)
			{
			color=((init[l]&k)>>m);
			color+=(((init[l+40]&k)>>m)<<1);
			color+=(((init[l+80]&k)>>m)<<2);
			color+=(((init[l+120]&k)>>m)<<3);

			init1[(i*320)+t]=color;
			if(disp==0)
				MEMPutpixel((t/2),i,color);
			else
				MEMPutpixel((t/2)+160,i,color+16);
			t++;
			m-=1;
			k>>=1;
			if(k==0 || m<0)
				{
				k=0x80;
				m=7;
				l++;
				}
			}
		l+=120;
		}
	if(init!=0) farfree(init);
	return init1;
	}
